Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim FR As Double
        Dim FL As Double
        Dim UG As Double
        Dim OG As Double
        Dim SW As Double
        Dim Anzahl As Integer
        Dim Zaehler As Integer
        Dim X() As Double
        Dim Y() As Double

        Dim FT As Double

        ' die zu integrierende Funktion ist gegeben durch
        ' f(x) = 1 / (1+x)

        UG = CType(Me.TextBox1.Text, Double)
        OG = CType(Me.TextBox2.Text, Double)
        SW = CType(Me.TextBox3.Text, Double)

        ' Berechnen der bentigten Rechenschritte
        Anzahl = CType((OG - UG) / SW, Integer)

        ' Entsprechend die Arrays dimensionieren
        ' da Index bei 0 beginnt, Anzahl um eins reduzieren
        ReDim X(Anzahl)
        ReDim Y(Anzahl)

        FR = 0.0#
        FL = 0.0#
        FT = 0.0#

        For Zaehler = 0 To Anzahl
            If Zaehler = 0 Then
                X(Zaehler) = UG
            Else
                X(Zaehler) = X(Zaehler - 1) + SW
            End If
            Y(Zaehler) = 1 / (1 + X(Zaehler))
        Next Zaehler

        ' Wurde Checkbox fr Rechteckregel ausgewhlt?
        If Me.CheckBox1.Checked Then
            ' Berechnen der Flche mit dem rechten Funktionswert
            For Zaehler = 0 To Anzahl - 1
                FR = FR + Math.Abs(X(Zaehler + 1) - X(Zaehler)) * Y(Zaehler + 1)
            Next Zaehler

            ' Berechnen der Flche mit dem linken Funktionswert
            For Zaehler = 0 To Anzahl - 1
                FL = FL + Math.Abs(X(Zaehler + 1) - X(Zaehler)) * Y(Zaehler)
            Next Zaehler

            ' Ausgabe der Ergebnisse
            Me.TextBox4.Text = Math.Round(FL, 4).ToString       ' linker Funktionswert
            Me.TextBox5.Text = Math.Round(FR, 4).ToString       ' rechter Funktionswert
            Me.TextBox6.Text = Math.Round((FL + FR) / 2, 4).ToString    ' mittlere Flche
        End If

        ' Wurde Checkbox fr Trapezregel ausgewhlt?
        If Me.CheckBox2.Checked Then
            For Zaehler = 0 To Anzahl - 1
                FT = FT + (Math.Abs(X(Zaehler) - X(Zaehler + 1))) * (Y(Zaehler) + Y(Zaehler + 1)) / 2
            Next Zaehler

            ' Ausgabe des Ergebnisses
            Me.TextBox7.Text = Math.Round(FT, 4).ToString
        End If
    End Sub

    Private Sub TextBox1_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox1.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox2_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox2.Validating
        If Not IsNumeric(Me.TextBox2.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox3_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox3.Validating
        If Not IsNumeric(Me.TextBox3.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub
End Class
